% ==============================================
%
% CBP 13-04-18
%
% Right Hand side for Wind Turbie Region II with
% simulated windspeed
%
% ==============================================
  
function xd=rhs_windturbine_2(t,x)

global R rho J windV LUT CpMax tsrOptim G C

xd = zeros(2,1);


theta = x(1);
omega = x(2);

% assert when wind speed changes
tt = cos(2*pi*t/3600);
if (tt >0.99)
windV = C*sqrt(-log(rand()));
endif

tsr = omega*R/windV;
if(tsr > 11) tsr = 11;
endif
if(tsr < 3) tsr = 3;
endif

Cp = lookupPowerCoefficient(tsr,3.7,LUT);

torqueW = (0.5*rho*pi*R**5)*(Cp/tsr**3)*omega**2;

kk = 0.5*rho*pi*(R**5)*CpMax/(tsrOptim**3);

% below original control law
%torqueG = kk*omega**2; 
% below optimal control law
torqueG = kk*omega^2 - G*(torqueW - kk*omega^2);

error =  (torqueW - torqueG);
 
xd(1) = x(2);
xd(2) = error/J;

endfunction

